
Flat data structures with attribute value pairs in attributes? Want to be able to weight your search results? Then this attribute boosting feature for the Lucene full-text search is for you. It will bring more dynamic scoring or weighting of your search results. ... Two flavours of dynamic weighting is available through the new pairs match-sibling-attribute, has-sibling-attribute and match-attribute, has-attribute child elements in the full-text index configuration. Let us look at them in turn. If you have data in Lexical metadata framework (LMF) format you will recognize these repeated structures of feat elements with att attributes and val attributes e g <feat att='writtenForm' val='LMF feature value structure'/> within LexicalEntry elements. Wouldn't it be nice to be able to weight the results based on the value of the att attribute so that hits in definitions come before hits in comments and examples? This is exactly what the match-sibling-attr addition enables. An example index configuration for it looks like this: <text qname='@val'> <match-sibling-attr q?name='att' value='writtenForm' boost='25'/> </text> This means that the ft:score#1 function will boost hits in 'val' attributes with a factor of 25 times for writtenForm value of the 'att' attribute. So you say you do not care about any value of the sibling attribute? Then the has-attribute index configuration variant could still come to rescue. An example index configuration with has-attr looks like this: <text qname='feat'> <has-attr q?name='xml:lang' boost='0'/> </text> This means that if your feat elements have an attribute 'xml:lang' it will score them nil and push them last of the pack, which might be useful to demote hits in features in other languages than the main entry language. A full example would be: I hope this have shown you how you can benefit from this new attribute boosting feature of the Lucene index configuration for dynamic scoring/weighting of flat attribute-based data structures. Enjoy!
